structure Label : sig

    type label

    val eq : label * label -> bool

    val new : unit -> label
    val named : string -> label

end = struct

    type label = Symbol.symbol

    val eq = Symbol.eq

    local
	val next = ref 0
    in
    fun new () =
	let val l = !next
	in
	    next := l + 1;
	    Symbol.fromString ("L" ^ Int.toString l)
	end
    end

    val named = Symbol.fromString

end
