structure Symbol :> sig

    type symbol

    val compare : symbol * symbol -> order
    val eq : symbol * symbol -> bool

    val fromString : string -> symbol
    val toString : symbol -> string

    structure Map : ORD_MAP where type Key.ord_key = symbol

end = struct

    type symbol = string
    val compare = String.compare
    fun eq (x: symbol, y) = x = y

    fun fromString s = s
    fun toString s = s

    structure Map = RedBlackMapFn (type ord_key = string
				   val compare = String.compare)
end
