structure Tree = struct

    type label = Label.label
    type size = int

    datatype binop =
	PLUS | MINUS | MUL | DIV 
      | AND | OR | LSHIFT | RSHIFT | ARSHIFT | XOR

    datatype relop =
	EQ | NE | LT | GT | LE | GE 
      | ULT | ULE | UGT | UGE

    datatype stm =
	SEQ of stm * stm
      | LABEL of label
      | JUMP of exp * label list
      | CJUMP of relop * exp * exp * label * label
      | MOVE of lexp * exp
      | EXP of exp

    and lexp =
	MEM of exp
      | TEMP of Temp.temp

    and exp =
	FETCH of lexp
      | BINOP of binop * exp * exp
      | ESEQ of stm * exp
      | NAME of label
      | CONST of LargeInt.int
      | CALL of exp * exp list

    fun notRel EQ = NE
      | notRel NE = EQ
      | notRel LT = GE
      | notRel GE = LT
      | notRel LE = GT
      | notRel GT = LE
      | notRel ULT = UGE
      | notRel UGE = ULT
      | notRel ULE = UGT
      | notRel UGT = ULE
end
